
Ruby - Bug #10727

Segfault with newlines + multibyte characters in exception message

01/10/2015 01:41 AM - eagletmt (Kohei Suzuki)

Status: Closed   

Priority: Normal   

Assignee: usa (Usaku NAKAMURA)   

Target version:    

ruby -v: ruby 2.2.0p0 (2014-12-25 revision

49005) [x86_64-linux]

Backport: 2.0.0: DONTNEED, 2.1: DONTNEED,

2.2: DONE

Description

In Ruby 2.2.0, this simple Ruby script results in segfault.

class E < StandardError

  def initialize

    super("にほんご\n改行")

  end

end

raise E

 It's caused by r48637.

Associated revisions

Revision 27c679b832c4600af81415c80741cb2619df5e08 - 01/10/2015 03:35 AM - U.Nakamura 

eval_error.c (error_print): pos and len parameters of rb_str_substr()

are counted by characters, not bytes.  use rb_str_subseq() instead.

[Bug #10727] [ruby-core:67473]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@49201 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 27c679b8 - 01/10/2015 03:35 AM - U.Nakamura 

eval_error.c (error_print): pos and len parameters of rb_str_substr()

are counted by characters, not bytes.  use rb_str_subseq() instead.

[Bug #10727] [ruby-core:67473]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@49201 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 54f1d71ab24d0c0a4dd49cfe6b1a0db07d89f81c - 01/10/2015 04:02 AM - nobu (Nobuyoshi Nakada)

test for [ruby-core:67473] [Bug #10727]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@49203 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 54f1d71a - 01/10/2015 04:02 AM - nobu (Nobuyoshi Nakada)

test for [ruby-core:67473] [Bug #10727]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@49203 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 6c4e9b2b9c9c3217cd40e549a407b2fa1939f420 - 01/17/2015 07:47 AM - naruse (Yui NARUSE)

merge revision(s) 49201,49203: [Backport #10727]

    * eval_error.c (error_print): pos and len parameters of rb_str_substr()

      are counted by characters, not bytes.  use rb_str_subseq() instead.

      [Bug #10727] [ruby-core:67473]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@49298 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 6c4e9b2b - 01/17/2015 07:47 AM - naruse (Yui NARUSE)
merge revision(s) 49201,49203: [Backport #10727]

    * eval_error.c (error_print): pos and len parameters of rb_str_substr()

      are counted by characters, not bytes.  use rb_str_subseq() instead.

      [Bug #10727] [ruby-core:67473]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@49298 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 01/10/2015 01:46 AM - hsbt (Hiroshi SHIBATA)

- Status changed from Open to Assigned

- Assignee set to usa (Usaku NAKAMURA)

I can reproduce this.

% ruby -v issue10727.rb

issue10727.rb:7:in `<main>': にほんご (E)

issue10727.rb: [BUG] Segmentation fault at 0x00000000000008

ruby 2.3.0dev (2015-01-09 trunk 49195) [x86_64-darwin13]

#2 - 01/10/2015 03:35 AM - usa (Usaku NAKAMURA)

- Status changed from Assigned to Closed

- % Done changed from 0 to 100

Applied in changeset r49201.

eval_error.c (error_print): pos and len parameters of rb_str_substr()

are counted by characters, not bytes.  use rb_str_subseq() instead.

[Bug #10727] [ruby-core:67473]

#3 - 01/10/2015 03:42 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.0.0: UNKNOWN, 2.1: UNKNOWN, 2.2: UNKNOWN to 2.0.0: DONTNEED, 2.1: DONTNEED, 2.2: REQUIRED

#4 - 01/10/2015 04:33 AM - eagletmt (Kohei Suzuki)

Thanks!

#5 - 01/17/2015 07:47 AM - naruse (Yui NARUSE)

- Backport changed from 2.0.0: DONTNEED, 2.1: DONTNEED, 2.2: REQUIRED to 2.0.0: DONTNEED, 2.1: DONTNEED, 2.2: DONE

ruby_2_2 r49298 merged revision(s) 49201,49203.
